<?php
/**
*
* @package Donation MOD with Multiple Payment Options
* @version $Id$
* @copyright (c) 2012 Siropu, www.siropu.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

$mod_name = 'Donation MOD with Multiple Payment Options';
$version_config_name = 'donation_mod_version';

$versions = array(
	'2.1.0' => array(
		'config_add' => array(
			array('donation_enable', '0', '0'),
			array('paypal_enable', '0', '0'),
			array('paypal_email', '', '0'),
			array('paypal_minimum', '1', '0'),
			array('paypal_currency', 'USD', '0'),
			array('paypal_preferred_currencies', 'USD,EUR', '0'),
			array('payza_enable', '0', '0'),
			array('payza_email', '', '0'),
			array('payza_minimum', '1', '0'),
			array('payza_currency', 'USD', '0'),
			array('payza_preferred_currencies', 'USD,EUR', '0'),
			array('moneybookers_enable', '0', '0'),
			array('moneybookers_email', '', '0'),
			array('moneybookers_minimum', '1', '0'),
			array('moneybookers_currency', 'USD', '0'),
			array('moneybookers_preferred_currencies', 'USD,EUR', '0'),
			array('libertyreserve_enable', '0', '0'),
			array('libertyreserve_account', '', '0'),
			array('libertyreserve_minimum', '1', '0'),
			array('libertyreserve_currency', 'USD', '0'),
			array('libertyreserve_preferred_currencies', 'USD,EUR', '0'),
			array('webmoney_enable', '0', '0'),
			array('webmoney_purse_wmz', '', '0'),
			array('webmoney_purse_wmr', '', '0'),
			array('webmoney_purse_wme', '', '0'),
			array('webmoney_purse_wmu', '', '0'),
			array('webmoney_purse_wmb', '', '0'),
			array('webmoney_purse_wmg', '', '0'),
			array('webmoney_minimum', '1', '0'),
			array('webmoney_currency', 'WMZ', '0'),
			array('donation_goal_enable', '0', '0'),
			array('donation_goal_amount_received', '0', '0'),
			array('donation_goal_amount', '100', '0'),
			array('donation_goal_currency', 'USD', '0'),
			array('donors_list_enable', '0', '0'),
			array('donors_list_top_five_enable', '0', '0'),
			array('donors_index_top_five_enable', '0', '0'),
			array('donors_last_five_enable', '0', '0'),
		),

		'table_add' => array(
			array('phpbb_donation_config', array(
					'COLUMNS' => array(
						'config_name'  => array('VCHAR', ''),
						'config_value' => array('TEXT', ''),
					),
					'PRIMARY_KEY'	=> 'config_name',
				),
			),
			array('phpbb_donation_donors', array(
					'COLUMNS' => array(
						'donor_id'          => array('UINT', NULL, 'auto_increment'),
						'donor_username'    => array('VCHAR', ''),
						'donation_amount'   => array('UINT', 0),
						'donation_currency' => array('VCHAR', ''),
						'donation_method'	=> array('VCHAR', ''),
						'donation_date'     => array('VCHAR', ''),
					),
					'PRIMARY_KEY' => 'donor_id',
				),
			),
		),

		'table_insert' => array(
			array('phpbb_donation_config', array(			
				array(			
					'config_name'  => 'donation_body',
					'config_value' => 'Support us by making a donation using one of the available payment options bellow.',
				),
				array(			
					'config_name'  => 'donation_success',
					'config_value' => 'Your donation was successful. Thank you!',
				),
				array(			
					'config_name'  => 'donation_cancel',
					'config_value' => 'Your donation was cancelled.',
				),
			)),			
		),

        'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_DONATION'),
			array('acp', 'ACP_DONATION', array(
					'module_basename' => 'donation',
					'modes'			  => array('config','goal','donors'),
					'module_auth'	  => 'acl_a_',
				),
			),
		),	

		'cache_purge' => array(
			'template',
			'theme',
			'cache',
		),
	),
	'2.1.1' => array(
	    'config_add' => array(
			array('non_members_donations_enable', '1', '0'),
		),
	),
	'2.1.2' => array(
	    'table_column_update' => array(
            array('phpbb_donation_donors', 'donation_amount' , array('DECIMAL:6', 0)),
		),
		'config_add' => array(
		    array('donation_goal_index_enable', '0', '0'),
			array('donation_goal_index_bottom', '1', '0'),
		),
	),
	'2.1.3' => array(),
	'2.2.0' => array(
		'config_add' => array(
		    array('donation_ipn_enable', '0', '0'),
			array('ipn_payza_security_code', '', '0'),
			array('ipn_moneybookers_secret_word', '', '0'),
			array('ipn_libertyreserve_security_word', '', '0'),
			array('ipn_libertyreserve_store_name', '', '0'),
		    array('donors_group_enable', '1', '0'),
			array('donors_group_id', '', '0'),
			array('donors_group_default', '0', '0'),
			array('donors_group_exceptions', '4,5', '0'),
			array('donation_send_donor_notification_pm', '1', '0'),
			array('donation_send_admin_notification_pm', '1', '0'),
		),
		'table_insert' => array(
			array('phpbb_donation_config', array(			
				array(			
					'config_name'  => 'donation_pm_subject',
					'config_value' => 'Thank you for your donation!',
				),
				array(			
					'config_name'  => 'donation_pm_body',
					'config_value' => 'We received your donation, thank you very much!',
				),
			)),			
		),
		'module_add' => array(
			array('acp', 'ACP_DONATION', array(
					'module_basename' => 'donation',
					'modes'			  => array('ipn'),
					'module_auth'	  => 'acl_a_',
				),
			),
		),	
	),
	'2.2.1' => array(
	    array('ipn_admin_user_id', '2', '0'),
	),
	'2.2.2' => array(),
	'2.2.3' => array(),
	'2.2.4' => array(),
);

include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>