<?php
/**
*
* @package Donation MOD with Multiple Payment Options
* @version $Id$
* @copyright (c) 2012 Siropu, www.siropu.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/donation');

// Donors list disabled
if (!$config['donors_list_enable'])
{
    trigger_error($user->lang['DONORS_LIST_DISABLED'], E_USER_NOTICE);
}

// Get the top 5 donors
$sql = 'SELECT *
	FROM ' . DONATION_DONORS_TABLE . '
	JOIN ' . USERS_TABLE . '
	ON donor_username=username
	ORDER BY donation_amount DESC';
$result = $db->sql_query_limit($sql, 5, 0);

while ($row = $db->sql_fetchrow($result))
{
	$template->assign_block_vars('top_five_donors', array(
		'DONOR_USERNAME'    => get_username_string('full', $row['user_id'], $row['donor_username'], $row['user_colour']),
		'DONATION_AMOUNT'   => $row['donation_amount'],
		'DONATION_CURRENCY' => $row['donation_currency'],
		'DONATION_METHOD'   => $row['donation_method'],
		'DONATION_DATE'     => (isset($row['donation_date']) && is_numeric($row['donation_date'])) ? $user->format_date($row['donation_date']) : $row['donation_date'],
		)
	);
}
$db->sql_freeresult($result);

// Generate donors list
$start = request_var('start', 0);
$limit = 25;

$sql = 'SELECT *
	FROM ' . DONATION_DONORS_TABLE . '
	JOIN ' . USERS_TABLE . '
	ON donor_username=username
	ORDER BY donor_id DESC';
$result = $db->sql_query_limit($sql, $limit, $start);

while ($row = $db->sql_fetchrow($result))
{
	$template->assign_block_vars('donorlist', array(
		'DONOR_USERNAME'    => get_username_string('full', $row['user_id'], $row['donor_username'], $row['user_colour']),
		'DONATION_AMOUNT'   => $row['donation_amount'],
		'DONATION_CURRENCY' => $row['donation_currency'],
		'DONATION_METHOD'   => $row['donation_method'],
		'DONATION_DATE'     => (isset($row['donation_date']) && is_numeric($row['donation_date'])) ? $user->format_date($row['donation_date']) : $row['donation_date'],
		)
	);
}
$db->sql_freeresult($result);

// Generate pagination
$sql = 'SELECT COUNT(donor_id) AS total_donors
	FROM ' . DONATION_DONORS_TABLE;
$result = $db->sql_query($sql);
$total_donors = (int) $db->sql_fetchfield('total_donors');

$pagination_url = append_sid($phpbb_root_path . 'donorlist.' . $phpEx);

$template->assign_vars(array(
    'PAGINATION'                  => generate_pagination($pagination_url, $total_donors, $limit, $start),
    'PAGE_NUMBER'                 => on_page($total_donors, $limit, $start),
    'TOTAL_DONORS'                => ($total_donors == 1) ? $user->lang['LIST_DONOR'] : sprintf($user->lang['LIST_DONORS'], $total_donors),
	'DONORS_LIST_ENABLE'          => $config['donors_list_enable'],
	'DONORS_LIST_TOP_FIVE_ENABLE' => $config['donors_list_top_five_enable'],
));

// Output the page
page_header($user->lang['DONORS_LIST']);
$template->set_filenames(array('body' => 'donate/donorlist.html'));

make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));
page_footer();

?>