<?php
/** 
*
* @package Donation MOD with Multiple Payment Options
* @version $Id$
* @copyright (c) 2012 Siropu, www.siropu.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}
/**
* @package acp
*/
class acp_donation
{
    var $u_action;

    function main($id, $mode)
    {
        global $db, $user, $auth, $template, $cache;
        global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

		$action = request_var('action', '');
		$action = (isset($_POST['add'])) ? 'add' : ((isset($_POST['save'])) ? 'save' : $action);
		$submit = (isset($_POST['submit'])) ? true : false;

		$s_hidden_fields = '';

		$sql = 'SELECT * 
		    FROM ' . DONATION_CONFIG_TABLE;
		$result = $db->sql_query($sql);

		$donation_config = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$donation_config[$row['config_name']] = $row['config_value'];
		}
		$db->sql_freeresult($result);

		$currencies = array_unique(explode(',',$config['paypal_preferred_currencies'] . ',' . $config['payza_preferred_currencies'] . ',' . $config['moneybookers_preferred_currencies'] . ',' . $config['libertyreserve_preferred_currencies']));
		
		function default_currency($list, $default)
		{
			$default_currency = '';

			foreach ($list as $currency)
			{
				if ($currency == $default)
				{
				    $default_currency .= '<option value="' . $currency . '" selected="selected">' . $currency . '</option>';
				}
				else
				{
					$default_currency .= '<option value="' . $currency . '">' . $currency . '</option>';
				}
		    }
		    return $default_currency;
		}

		// Thanks dynamicguru.com for this useful function
		function currency_convert($from_Currency,$to_Currency,$amount) 
        {
            $amount = urlencode($amount);
            $from_Currency = urlencode($from_Currency);
            $to_Currency = urlencode($to_Currency);
            $url = "http://www.google.com/ig/calculator?hl=en&q=$amount$from_Currency=?$to_Currency";
            $ch = curl_init();
            $timeout = 0;
            curl_setopt ($ch, CURLOPT_URL, $url);
            curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt ($ch, CURLOPT_USERAGENT , "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1)");
            curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
            $rawdata = curl_exec($ch);
            curl_close($ch);
            $data = explode('"', $rawdata);
            $data = explode(' ', $data['3']);
            $var = $data['0'];
            return round($var,1);
        }

		switch ($mode) 
		{
			case 'config':

                $this->tpl_name   = 'acp_donation_config';
                $this->page_title = 'ACP_DONATION_CONFIG';

		        $donation_enable                     = request_var('donation_enable', 0);
		        $paypal_enable                       = request_var('paypal_enable', 0);
		        $paypal_email                        = request_var('paypal_email', '');
		        $paypal_minimum                      = request_var('paypal_minimum', 0.0);
		        $paypal_currency                     = request_var('paypal_currency', '');
				$paypal_preferred_currencies         = request_var('paypal_preferred_currencies', array('' => ''));
		        $payza_enable                        = request_var('payza_enable', 0);
		        $payza_email                         = request_var('payza_email', '');
		        $payza_minimum                       = request_var('payza_minimum', 0.0);
		        $payza_currency                      = request_var('payza_currency', '');
				$payza_preferred_currencies          = request_var('payza_preferred_currencies', array('' => ''));
		        $moneybookers_enable                 = request_var('moneybookers_enable', 0);
		        $moneybookers_email                  = request_var('moneybookers_email', '');
		        $moneybookers_minimum                = request_var('moneybookers_minimum', 0.0);
		        $moneybookers_currency               = request_var('moneybookers_currency', '');
				$moneybookers_preferred_currencies   = request_var('moneybookers_preferred_currencies', array('' => ''));
		        $libertyreserve_enable               = request_var('libertyreserve_enable', 0);
		        $libertyreserve_account              = request_var('libertyreserve_account', '');
		        $libertyreserve_minimum              = request_var('libertyreserve_minimum', 0.0);
		        $libertyreserve_currency             = request_var('libertyreserve_currency', '');
				$libertyreserve_preferred_currencies = request_var('libertyreserve_preferred_currencies', array('' => ''));
				$webmoney_enable                     = request_var('webmoney_enable', 0);
				$webmoney_purse_wmz                  = request_var('webmoney_purse_wmz', '');
				$webmoney_purse_wmr                  = request_var('webmoney_purse_wmr', '');
				$webmoney_purse_wme                  = request_var('webmoney_purse_wme', '');
				$webmoney_purse_wmu                  = request_var('webmoney_purse_wmu', '');
				$webmoney_purse_wmb                  = request_var('webmoney_purse_wmb', '');
				$webmoney_purse_wmg                  = request_var('webmoney_purse_wmg', '');
		        $webmoney_minimum                    = request_var('webmoney_minimum', 0.0);
		        $webmoney_currency                   = request_var('webmoney_currency', '');
		        $donation_goal_enable                = request_var('donation_goal_enable', 0);
				$donation_goal_index_enable          = request_var('donation_goal_index_enable', 0);
				$donation_goal_index_bottom          = request_var('donation_goal_index_bottom', 0);
				$donors_list_enable                  = request_var('donors_list_enable', 0);
				$donors_list_top_five_enable         = request_var('donors_list_top_five_enable', 0);
				$donors_index_top_five_enable        = request_var('donors_index_top_five_enable', 0);
				$donors_last_five_enable             = request_var('donors_last_five_enable', 0);
				$non_members_donations_enable        = request_var('non_members_donations_enable', 0);

		        $donation_page_config = array(
			        'donation_body'	   => utf8_normalize_nfc(request_var('donation_body', '', true)),
			        'donation_success' => utf8_normalize_nfc(request_var('donation_success', '', true)),
			        'donation_cancel'  => utf8_normalize_nfc(request_var('donation_cancel', '', true)),		
		        );

	            if ($submit)
		        {
			        set_config('donation_enable', $donation_enable);
			        set_config('paypal_enable', $paypal_enable);
			        set_config('paypal_email', $paypal_email);
			        set_config('paypal_minimum', $paypal_minimum);
			        set_config('paypal_currency', $paypal_currency);
					set_config('paypal_preferred_currencies', implode(',',$paypal_preferred_currencies));
	    	        set_config('payza_enable', $payza_enable);
			        set_config('payza_email', $payza_email);
			        set_config('payza_minimum', $payza_minimum);
			        set_config('payza_currency', $payza_currency);
					set_config('payza_preferred_currencies', implode(',',$payza_preferred_currencies));
			        set_config('moneybookers_enable', $moneybookers_enable);
			        set_config('moneybookers_email', $moneybookers_email);
			        set_config('moneybookers_minimum', $moneybookers_minimum);
			        set_config('moneybookers_currency', $moneybookers_currency);
					set_config('moneybookers_preferred_currencies', implode(',',$moneybookers_preferred_currencies));
			        set_config('libertyreserve_enable', $libertyreserve_enable);
    		        set_config('libertyreserve_account', $libertyreserve_account);
			        set_config('libertyreserve_minimum', $libertyreserve_minimum);
			        set_config('libertyreserve_currency', $libertyreserve_currency);
					set_config('libertyreserve_preferred_currencies', implode(',',$libertyreserve_preferred_currencies));
					set_config('webmoney_enable', $webmoney_enable);
    		        set_config('webmoney_purse_wmz', $webmoney_purse_wmz);
    		        set_config('webmoney_purse_wmr', $webmoney_purse_wmr);
					set_config('webmoney_purse_wme', $webmoney_purse_wme);
					set_config('webmoney_purse_wmu', $webmoney_purse_wmu);
					set_config('webmoney_purse_wmb', $webmoney_purse_wmb);
					set_config('webmoney_purse_wmg', $webmoney_purse_wmg);
			        set_config('webmoney_minimum', $webmoney_minimum);
			        set_config('webmoney_currency', $webmoney_currency);
			        set_config('donation_goal_enable', $donation_goal_enable);
					set_config('donation_goal_index_enable', $donation_goal_index_enable);
					set_config('donation_goal_index_bottom', $donation_goal_index_bottom);
					set_config('donors_list_enable', $donors_list_enable);
					set_config('donors_list_top_five_enable', $donors_list_top_five_enable);
					set_config('donors_index_top_five_enable', $donors_index_top_five_enable);
					set_config('donors_last_five_enable', $donors_last_five_enable);
					set_config('non_members_donations_enable', $non_members_donations_enable);

		            foreach ($donation_page_config as $config_name => $config_value)
				    {
					    $sql = 'UPDATE ' . DONATION_CONFIG_TABLE . "
						    SET config_value = '" . $db->sql_escape($config_value) . "'
						    WHERE config_name = '" . $db->sql_escape($config_name) . "'";
					    $db->sql_query($sql);
				    }

		            trigger_error(sprintf($user->lang['CONFIG_UPDATED']) . adm_back_link($this->u_action));
		        }

				$paypal_currencies = array('USD','EUR','AUD','BRL','CAD','CHF','CZK','DKK','GBP','HKD','HUF','ILS','JPY','MXN','MYR','NOK','NZD','PHP','PLN','SEK','SGD','THB','TRY','TWD');

		        $payza_currencies = array('USD','EUR','AUD','BGN','CAD','CHF','CZK','DKK','EEK','GBP','HKD','HUF','INR','LTL','MYR','MKD','NOK','NZD','PLN','RON','SEK','SGD','ZAR');

		        $moneybookers_currencies = array('USD','EUR','AED','AUD','BGN','CAD','CHF','CZK','DKK','EEK','GBP','HKD','HRK','HUF','ILS','INR','ISK','JOD','JPY','KRW','LTL','LVL','MAD','MYR','NOK','NZD','OMR','PLN','QAR','RON','RSD','SAR','SEK','SGD','SKK','THB','TND','TRY','TWD','ZAR');

		        $libertyreserve_currencies = array('USD','EUR','GLD');

				function preferred_currencies($list, $preferred)
				{
				    $preferred_currencies = '';

				    foreach ($list as $currency)
				    {
				        if (in_array($currency,explode(',',$preferred)))
					    {
				            $preferred_currencies .= '<option value="' . $currency . '" selected="selected">' . $currency . '</option>';
					    }
					    else
					    {
					        $preferred_currencies .= '<option value="' . $currency . '">' . $currency . '</option>';
					    }
				    }
					return $preferred_currencies;
				}

				$template->assign_vars(array(
			        'DONATION_ENABLE'                     => $config['donation_enable'],
					'DONATION_GOAL_ENABLE'                => $config['donation_goal_enable'],
					'DONATION_GOAL_INDEX_ENABLE'          => $config['donation_goal_index_enable'],
					'DONATION_GOAL_INDEX_BOTTOM'          => $config['donation_goal_index_bottom'],
					'DONORS_LIST_ENABLE'                  => $config['donors_list_enable'],	
					'DONORS_LIST_TOP_FIVE_ENABLE'         => $config['donors_list_top_five_enable'],
					'DONORS_INDEX_TOP_FIVE_ENABLE'        => $config['donors_index_top_five_enable'],
					'DONORS_LAST_FIVE_ENABLE'             => $config['donors_last_five_enable'],
					'NON_MEMBERS_DONATIONS_ENABLE'        => $config['non_members_donations_enable'],
			        'PAYPAL_ENABLE'                       => $config['paypal_enable'],
			        'PAYPAL_EMAIL'                        => $config['paypal_email'],
			        'PAYPAL_MINIMUM'                      => $config['paypal_minimum'],
			        'PAYPAL_CURRENCY'                     => default_currency($paypal_currencies, $config['paypal_currency']),
					'PAYPAL_PREFERRED_CURRENCIES'         => preferred_currencies($paypal_currencies, $config['paypal_preferred_currencies']),
			        'PAYZA_ENABLE'                        => $config['payza_enable'],
			        'PAYZA_EMAIL'	                      => $config['payza_email'],
			        'PAYZA_MINIMUM'                       => $config['payza_minimum'],
			        'PAYZA_CURRENCY'                      => default_currency($payza_currencies, $config['payza_currency']),
					'PAYZA_PREFERRED_CURRENCIES'          => preferred_currencies($payza_currencies, $config['payza_preferred_currencies']),
			        'MONEYBOOKERS_ENABLE'                 => $config['moneybookers_enable'],
			        'MONEYBOOKERS_EMAIL'	              => $config['moneybookers_email'],
			        'MONEYBOOKERS_MINIMUM'	              => $config['moneybookers_minimum'],
			        'MONEYBOOKERS_CURRENCY'               => default_currency($moneybookers_currencies, $config['moneybookers_currency']),
					'MONEYBOOKERS_PREFERRED_CURRENCIES'   => preferred_currencies($moneybookers_currencies, $config['moneybookers_preferred_currencies']),
			        'LIBERTYRESERVE_ENABLE'               => $config['libertyreserve_enable'],
			        'LIBERTYRESERVE_ACCOUNT'              => $config['libertyreserve_account'],
			        'LIBERTYRESERVE_MINIMUM'              => $config['libertyreserve_minimum'],
			        'LIBERTYRESERVE_CURRENCY'             => default_currency($libertyreserve_currencies, $config['libertyreserve_currency']),
					'LIBERTYRESERVE_PREFERRED_CURRENCIES' => preferred_currencies($libertyreserve_currencies, $config['libertyreserve_preferred_currencies']),
					'WEBMONEY_ENABLE'                     => $config['webmoney_enable'],
			        'WEBMONEY_PURSE_WMZ'                  => $config['webmoney_purse_wmz'],
					'WEBMONEY_PURSE_WMR'                  => $config['webmoney_purse_wmr'],
					'WEBMONEY_PURSE_WME'                  => $config['webmoney_purse_wme'],
					'WEBMONEY_PURSE_WMU'                  => $config['webmoney_purse_wmu'],
					'WEBMONEY_PURSE_WMB'                  => $config['webmoney_purse_wmb'],
					'WEBMONEY_PURSE_WMG'                  => $config['webmoney_purse_wmg'],
			        'WEBMONEY_MINIMUM'                    => $config['webmoney_minimum'],
			        'WEBMONEY_CURRENCY'                   => $config['webmoney_currency'],
			        'DONATION_BODY'                       => $donation_config['donation_body'],
			        'DONATION_SUCCESS'                    => $donation_config['donation_success'],
			        'DONATION_CANCEL'                     => $donation_config['donation_cancel'],
                    'U_DONATE'                            => generate_board_url() . "/donate.$phpEx",
			        'U_DONATE_SUCCESS'                    => generate_board_url() . "/donate.$phpEx?action=success",
	                'U_DONATE_CANCEL'                     => generate_board_url() . "/donate.$phpEx?action=cancel",
                    )
		        );

		    break;

		    case 'goal':

		        $this->tpl_name   = 'acp_donation_goal';
                $this->page_title = 'ACP_DONATION_GOAL';

		        $donation_goal_amount_received = request_var('donation_goal_amount_received', 0.0);
		        $donation_goal_amount          = request_var('donation_goal_amount', 0.0);
		        $donation_goal_currency        = request_var('donation_goal_currency', '');		        

	            if ($submit)
		        {
    		        set_config('donation_goal_amount_received', $donation_goal_amount_received);
			        set_config('donation_goal_amount', $donation_goal_amount);
			        set_config('donation_goal_currency', $donation_goal_currency);
				
		            trigger_error(sprintf($user->lang['CONFIG_UPDATED']) . adm_back_link($this->u_action));
		        }

				$template->assign_vars(array(
			        'DONATION_GOAL_AMOUNT_RECEIVED' => $config['donation_goal_amount_received'],
			        'DONATION_GOAL_AMOUNT'          => $config['donation_goal_amount'],
			        'DONATION_GOAL_CURRENCY'        => (isset($config['donation_goal_currency'])) ? default_currency($currencies, $config['donation_goal_currency']) : default_currency($currencies, 'USD'),
                    )
		        );

		    break;

			case 'donors':

		        $this->tpl_name   = 'acp_donation_donors';
                $this->page_title = 'ACP_DONATION_DONORS';

		        $form_name = 'acp_donation_donors';
		        add_form_key($form_name);

				switch ($action)
				{
				    case 'edit':

						$donor_id = request_var('id', 0);

						$sql = 'SELECT *
					        FROM ' . DONATION_DONORS_TABLE . "
					        WHERE donor_id = $donor_id";
				        $result = $db->sql_query($sql);
				        $donor_info = $db->sql_fetchrow($result);
				        $db->sql_freeresult($result);

						$s_hidden_fields .= '<input type="hidden" name="id" value="' . $donor_id . '" />';

				    case 'add':

				        $template->assign_vars(array(
					        'S_EDIT_DONOR'		    => true,
					        'U_BACK'			    => $this->u_action,
							'DONOR_USERNAME'        => (isset($donor_info['donor_username'])) ? $donor_info['donor_username'] : '',
					        'DONATION_AMOUNT'       => (isset($donor_info['donation_amount'])) ? $donor_info['donation_amount'] : '',
							'DONATION_CURRENCY'     => (isset($donor_info['donation_currency'])) ? default_currency($currencies, $donor_info['donation_currency']) : default_currency($currencies, 'USD'),
							'DONATION_METHOD'       => (isset($donor_info['donation_method'])) ? $donor_info['donation_method'] : '',	
						    )
				        );

						$donation_date = (isset($donor_info['donation_date'])) ? $donor_info['donation_date'] : time();
						$s_hidden_fields .= '<input type="hidden" name="donation_date" value="' . $donation_date . '" />';
	
                    break;

                    case 'save':

				        if (!check_form_key($form_name))
				        {
					        trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
				        }

					    $donor_id            = request_var('id', 0);
				        $donor_username		 = utf8_normalize_nfc(request_var('donor_username', '', true));
				        $donation_amount     = request_var('donation_amount', 0.0);
				        $donation_currency	 = request_var('donation_currency', '');
					    $donation_method     = request_var('donation_method', '');
				        $donation_date		 = request_var('donation_date', '');

				        if ($donor_username === '' || $donation_amount === '' || $donation_date === '')
				        {
				 	        trigger_error($user->lang['ENTER_DONOR_INFO'] . adm_back_link($this->u_action), E_USER_WARNING);
				        }

						$sql = 'SELECT *
					        FROM ' . DONATION_DONORS_TABLE . "
					        WHERE donor_id = $donor_id";
				        $result = $db->sql_query($sql);
				        $donor_info = $db->sql_fetchrow($result);
				        $db->sql_freeresult($result);

						if (!empty($donor_id))
						{
						    if ($donation_currency != $config['donation_goal_currency'] || $donation_currency != $donor_info['donation_currency'])
							{
						        $donation_goal_amount_received = $config['donation_goal_amount_received'] - currency_convert($donor_info['donation_currency'],$config['donation_goal_currency'],$donor_info['donation_amount']) + currency_convert($donation_currency,$config['donation_goal_currency'],$donation_amount);
							    set_config('donation_goal_amount_received', $donation_goal_amount_received);
							}
							else
							{
							    $donation_goal_amount_received = $config['donation_goal_amount_received'] - $donor_info['donation_amount'] + $donation_amount;
							    set_config('donation_goal_amount_received', $donation_goal_amount_received);
							}
						}
						else
						{
						    if ($donation_currency != $config['donation_goal_currency'])
							{
						        $donation_goal_amount_received = $config['donation_goal_amount_received'] + currency_convert($donation_currency,$config['donation_goal_currency'],$donation_amount);
							    set_config('donation_goal_amount_received', $donation_goal_amount_received);
							}
							else
							{
							    $donation_goal_amount_received = $config['donation_goal_amount_received'] + $donation_amount;
							    set_config('donation_goal_amount_received', $donation_goal_amount_received);
							}
						}

				        $sql_ary = array(
					        'donor_username'    => $donor_username,
					        'donation_amount'   => $donation_amount,
					        'donation_currency' => $donation_currency,
						    'donation_method'   => $donation_method,
					        'donation_date'     => $donation_date,
				        );
	
				        if ($donor_id)
				        {
					        $db->sql_query('UPDATE ' . DONATION_DONORS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE donor_id = ' . $donor_id);
				        }
				        else
				        {
					        $db->sql_query('INSERT INTO ' . DONATION_DONORS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));
							
							// Add donor to the specified group

							$sql = 'SELECT group_id
								FROM ' . USERS_TABLE . '
								WHERE username="' . $db->sql_escape($donor_username) . '"';
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$group_id = $row['group_id'];
							$db->sql_freeresult($result);

							if ($config['donors_group_enable'])
							{
								if ($config['donors_group_default']  && !in_array($group_id, explode(',', $config['donors_group_exceptions'])))
								{
									$default = true;
								}
								else
								{
									$default = false;
								}

								group_user_add($config['donors_group_id'], false, $donor_username, false, $default, 0, 0, false);
							}
				        }

				        $message = ($donor_id) ? $user->lang['DONOR_INFO_UPDATED'] : $user->lang['DONOR_ADDED'];
				        trigger_error($message . adm_back_link($this->u_action));

			        break;

			        case 'delete':

				        $donor_id = request_var('id', 0);

				        if (!$donor_id)
				        {
					        trigger_error($user->lang['NO_DONOR_SELECTED'] . adm_back_link($this->u_action), E_USER_WARNING);
				        }
		
						$sql = 'SELECT *
					        FROM ' . DONATION_DONORS_TABLE . "
					        WHERE donor_id = $donor_id";
				        $result = $db->sql_query($sql);
				        $donor_info = $db->sql_fetchrow($result);
				        $db->sql_freeresult($result);

						$remove_donation_from_goal = isset($_POST['remove_donation_from_goal']) ? true : false;
							
						if ($remove_donation_from_goal)
						{
							if ($donor_info['donation_currency'] != $config['donation_goal_currency'])
							{
						        $donation_goal_amount_received = $config['donation_goal_amount_received'] - currency_convert($donor_info['donation_currency'],$config['donation_goal_currency'],$donor_info['donation_amount']);
							    set_config('donation_goal_amount_received', $donation_goal_amount_received);
						    }
							else
							{
							    $donation_goal_amount_received = $config['donation_goal_amount_received'] - $donor_info['donation_amount'];
							    set_config('donation_goal_amount_received', $donation_goal_amount_received);
						    }
						}

				        if (confirm_box(true))
				        {
							$sql = 'SELECT * 
								FROM ' . DONATION_DONORS_TABLE . "
								WHERE donor_id = $donor_id";
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$donor_username   = array();
							$donor_username[] = $row['donor_username'];
							$db->sql_freeresult($result);

							group_user_del($config['donors_group_id'], false, $donor_username);

					        $sql = 'DELETE FROM ' . DONATION_DONORS_TABLE . "
						        WHERE donor_id = $donor_id";
					        $db->sql_query($sql);

					        trigger_error($user->lang['DONOR_REMOVED'] . adm_back_link($this->u_action));
				        }
				        else
				        {
					        confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
						        'i'			=> $id,
						        'mode'		=> $mode,
						        'id'		=> $donor_id,
						        'action'	=> 'delete',
					        ))

							. '<input type="checkbox" name="remove_donation_from_goal" id="remove_donation_from_goal" class="radio" /><label for="remove_donation_from_goal"> ' . $user->lang['REMOVE_AMOUNT_FROM_GOAL_STATISTICS']
							. '</label>'

							);
				        }

			        break;
				}

				$start = request_var('start', 0);
                $limit = 25;

                $sql = 'SELECT *
	                FROM ' . DONATION_DONORS_TABLE . '
					LEFT JOIN ' . USERS_TABLE . '
					ON donor_username=username
	                ORDER BY donor_id DESC';
                $result = $db->sql_query_limit($sql, $limit, $start);

		        while ($row = $db->sql_fetchrow($result))
		        {
			        $template->assign_block_vars('donors_list', array(
				        'DONOR_USERNAME'    => get_username_string('full', $row['user_id'], $row['donor_username'], $row['user_colour']),
				        'DONATION_AMOUNT'   => $row['donation_amount'],
				        'DONATION_CURRENCY' => $row['donation_currency'],
				        'DONATION_METHOD'   => $row['donation_method'],
				        'DONATION_DATE'     => (isset($row['donation_date']) && is_numeric($row['donation_date'])) ? $user->format_date($row['donation_date']) : $row['donation_date'],
				        'U_EDIT'		    => $this->u_action . '&amp;action=edit&amp;id=' . $row['donor_id'],
				        'U_DELETE'		    => $this->u_action . '&amp;action=delete&amp;id=' . $row['donor_id']
				       )
			        );
		        }
		        $db->sql_freeresult($result);

                $sql = 'SELECT COUNT(donor_id) AS total_donors
			        FROM ' . DONATION_DONORS_TABLE;
                $result = $db->sql_query($sql);
                $total_donors = (int) $db->sql_fetchfield('total_donors');

                $template->assign_vars(array(
                    'PAGINATION'          => generate_pagination($this->u_action, $total_donors, $limit, $start, true),
			        'S_ON_PAGE'		      => on_page($total_donors, $limit, $start),
                    'TOTAL_DONORS'        => ($total_donors == 1) ? $user->lang['LIST_DONOR'] : sprintf($user->lang['LIST_DONORS'], $total_donors),
                    )
		        );	

		    break;

			case 'ipn':

			    $this->tpl_name   = 'acp_donation_ipn';
                $this->page_title = 'ACP_DONATION_IPN';

				$donation_ipn_enable              = request_var('donation_ipn_enable', 0);
				$ipn_payza_security_code          = request_var('ipn_payza_security_code', '');
				$ipn_moneybookers_secret_word     = request_var('ipn_moneybookers_secret_word', '');
				$ipn_libertyreserve_security_word = request_var('ipn_libertyreserve_security_word', '');
				$ipn_libertyreserve_store_name    = request_var('ipn_libertyreserve_store_name', '');
				$donors_group_enable              = request_var('donors_group_enable', 0);
				$donors_group_id                  = request_var('donors_group_id', 0);
		        $donors_group_default             = request_var('donors_group_default', 0);
				$donors_group_exceptions          = request_var('donors_group_exceptions', array(0 => 0));
				$send_donor_notification_pm       = request_var('send_donor_notification_pm', 0);
				$send_admin_notification_pm       = request_var('send_admin_notification_pm', 0);
				$admin_user_id                    = request_var('admin_user_id', 0);

				$donation_page_config = array(
			        'donation_pm_subject'	=> utf8_normalize_nfc(request_var('donation_pm_subject', '', true)),
			        'donation_pm_body'	=> utf8_normalize_nfc(request_var('donation_pm_body', '', true)),
		        );

				if ($submit)
		        {
				    set_config('donation_ipn_enable', $donation_ipn_enable);
					set_config('ipn_payza_security_code', $ipn_payza_security_code);
					set_config('ipn_moneybookers_secret_word', $ipn_moneybookers_secret_word);
					set_config('ipn_libertyreserve_security_word', $ipn_libertyreserve_security_word);
					set_config('ipn_libertyreserve_store_name', $ipn_libertyreserve_store_name);
				    set_config('donors_group_enable', $donors_group_enable);
					set_config('donors_group_id', $donors_group_id);
					set_config('donors_group_default', $donors_group_default);
					set_config('donors_group_exceptions', implode(',' ,$donors_group_exceptions));
					set_config('donation_send_donor_notification_pm', $send_donor_notification_pm);
					set_config('donation_send_admin_notification_pm', $send_admin_notification_pm);
					set_config('ipn_admin_user_id', $admin_user_id);

					foreach ($donation_page_config as $config_name => $config_value)
				    {
					    $sql = 'UPDATE ' . DONATION_CONFIG_TABLE . "
						    SET config_value = '" . $db->sql_escape($config_value) . "'
						    WHERE config_name = '" . $db->sql_escape($config_name) . "'";
					    $db->sql_query($sql);
				    }

					trigger_error(sprintf($user->lang['CONFIG_UPDATED']) . adm_back_link($this->u_action));
				}

				$sql = 'SELECT group_id, group_type, group_name
                    FROM ' . GROUPS_TABLE;
                $result = $db->sql_query($sql);
                $row = $db->sql_fetchrow($result);

				$donors_group_options = '';
                $donors_group_exceptions_options = '';
				
				while ($row = $db->sql_fetchrow($result))
				{
				    if ($row['group_type'] != GROUP_SPECIAL)
					{
					    if($row['group_id'] == $config['donors_group_id'])
						{
					        $donors_group_options .= '<option value="' . $row['group_id'] . '" selected="selected">' . $row['group_name'] . '</option>';
						}
						else
					    {
					        $donors_group_options .= '<option value="' . $row['group_id'] . '">' . $row['group_name'] . '</option>';
					    }
					}

                    if ($row['group_name'] != 'BOTS')
					{
					    if (in_array($row['group_id'],explode(',',$config['donors_group_exceptions'])))
				        {
						    $donors_group_exceptions_options .= '<option value="' . $row['group_id'] . '" selected="selected">' . $row['group_name'] . '</option>';
				        }
					    else
					    {
						    $donors_group_exceptions_options .= '<option value="' . $row['group_id'] . '">' . $row['group_name'] . '</option>';
					    }
					}
				}
				$db->sql_freeresult($result);

				$template->assign_vars(array(
				    'DONATION_IPN_ENABLE'              => $config['donation_ipn_enable'],
					'IPN_PAYZA_SECURITY_CODE'          => $config['ipn_payza_security_code'],
					'IPN_MONEYBOOKERS_SECRET_WORD'     => $config['ipn_moneybookers_secret_word'],
					'IPN_LIBERTYRESERVE_SECURITY_WORD' => $config['ipn_libertyreserve_security_word'],
					'IPN_LIBERTYRESERVE_STORE_NAME'    => $config['ipn_libertyreserve_store_name'],
					'IPN_PAYPAL_URL'                   => generate_board_url() . "/donation/ipn.$phpEx?action=paypal",
				    'DONORS_GROUP_ENABLE'              => $config['donors_group_enable'],
					'DONORS_GROUP_OPTIONS'             => ($donors_group_options) ? $donors_group_options : '<option>' . $user->lang['NO_CUSTOM_GROUP_FOUND'] . '</option> ',
					'DONORS_GROUP_DEFAULT'             => $config['donors_group_default'],
					'DONORS_GROUP_EXCEPTIONS_OPTIONS'  => $donors_group_exceptions_options,
					'SEND_DONOR_NOTIFICATION_PM'       => $config['donation_send_donor_notification_pm'],
					'SEND_ADMIN_NOTIFICATION_PM'       => $config['donation_send_admin_notification_pm'],
					'DONATION_PM_SUBJECT'              => $donation_config['donation_pm_subject'],
					'DONATION_PM_BODY'                 => $donation_config['donation_pm_body'],
                    )
		        );

				$s_hidden_fields .= '<input type="hidden" name="admin_user_id" value="' . $user->data['user_id'] . '" />';

			break;
		}

		// Global vars
		$template->assign_vars(array(
			'MOD_VERSION'     => $config['donation_mod_version'],
		    'U_ACTION'		  => $this->u_action,
			'S_HIDDEN_FIELDS' => $s_hidden_fields,
            )
		);

	}
}
?>